*

*

***************************************************************

*                                                             *

*     MC68HC705J1A                File Name: 705J1A_5.asm     *

*                                       June 8  1997          *

* Author : Patrick Charles                                    *

*          78-35 147 th Street                                *

*          Flushing, N.Y. 11367                               *

*                                                             *

* @ All rights reserved                                       *

***************************************************************

*

*

*

***************************************************************

*           WATER TANK MONITORING SOFTWARE                    *

*   This program will read the status of 2 lines on port B    *

*   they are PB5 and PB3. PB5 monitor the upper water level.  *                                     

*   PB3 monitor the lower water level.                        *                              

*   The table below represent the water level status.         *                 

*                                                             *

*                          TABLE                              *  

*                                                             *

*        PB5    PB3             Status                        *

*                                                             *

*        lo      lo          Tank is full                     *  

*        hi      lo          Tank is half full                *

*        hi      hi          Tank is empty                    * 

*                                                             *   

*   This project is based on the Motorola MC68hc705j1a        *                             *

*                                                             *

***************************************************************

*

*** Declare all variables *************************************

*

TEMPA    EQU     $C0

*

*

*********************************************

*          MAIN PROGRAM START HERE          *

*********************************************

	  ORG     ROM

*

*   INITIALIZE PORT A AND B

*

*

START:    RSP                 ; RESET STACK POINTER (SET TO FF)

	  CLRX

	  LDA     #00

	  STA     TEMPA       ; CLEAR TEMPA

	  LDA     #$FF

	  STA     DDRA        ; SET PORT A AS OUTPUT

	  LDA     #$05        ; SET PB0 & PB2 AS OUTPUT

	  STA     DDRB        ; SET PB1,PB3,PB4 & PB5 AS INPUT

	  LDA     #00         ;

	  STA     PORTA       ; CLEAR ALL CONTROL LINES

	  JSR     WUPDELAY    ; DISPLAY WARM-UP DELAY

	  CLI                 ; ENABLE INTERRUPT         

* 

	  JSR     INIT        ; INITIALIZE DISPLAY

	  LDA     #$80        ; SET DD RAM

	  JSR     CONTROL

	  LDA     #$00

	  JSR     CONTROL

	  LDA     #$00

	  JSR     CONTROL

	  LDA     #$20

	  JSR     CONTROL

**   DISPLAY "TANK IS FULL " **

LOOP1:    JSR     TANK

	  JSR     FULL

	  JSR     BLANK

	  BRCLR   5,PORTB,SENSOR2  ; READ PB5

*                                ; IF LO GO TO

*                                ; LOW LEVEL SENSOR

**                                    **

**      DISPLAY  "TANK IS HALF FULL " **

**                                    **

POLL2:    JSR     TANK

	  JSR     HALF

	  JSR     FULL

SENSOR2:  BRCLR   3,PORTB,SENSOR1 ;READ PB3

*                               ; IF LO GO TO 

*                               ; HIGH LEVEL SENSOR 

**                                   **

**      DISPLAY "TANK IS EMPTY "     **          

**                                   **                     

	  JSR     TANK

	  JSR     EMPTY

	  JSR     BLANK

	  JMP     POLL1       ; GO CHECK LO LEVEL SENSOR

SENSOR1:  BRCLR   5,PORTB,AGAIN ; READ PB5 

*                             ; IF LO 

*                             ; DISPLAY "TANK IS FULL"

POLL1:    BRSET   3,PORTB,POLL1 ; CHECK LO LEVEL SENSOR

	  JMP     POLL2       ; DISPLAY HALF FULL

AGAIN:    JMP     LOOP1       ; DISPLAY FULL

		



****************************************************

*              END OF MAIN PROGRAM                 *

****************************************************



****************************************************                                              

*            DISPLAY MESSAGE AREA                  *

****************************************************

*

FULL:     LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$40        ; DISPLAY FULL

	  JSR    DISLET    

	  LDA    #$60

	  JSR    DISLET

	  LDA    #$50

	  JSR    DISLET

	  LDA    #$50

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$C0

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$C0

	  JSR    DISLET

	  RTS

*

*

TANK:     LDA    #$80

	  JSR    CONTROL

	  LDA    #$00

	  JSR    CONTROL

	  LDA    #$00

	  JSR    CONTROL

	  LDA    #$20

	  JSR    CONTROL

	  LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$50

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$10

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$E0

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$B0

	  JSR    DISLET

	  RTS

*

EMPTY:    LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$50

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$D0

	  JSR    DISLET

	  LDA    #$50

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$50

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$50

	  JSR    DISLET

	  LDA    #$90

	  JSR    DISLET

	  RTS

*

HALF:     LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$80

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$10

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$C0

	  JSR    DISLET

	  LDA    #$40

	  JSR    DISLET

	  LDA    #$60

	  JSR    DISLET

	  RTS

*

BLANK:    LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  LDA    #$20

	  JSR    DISLET

	  LDA    #$00

	  JSR    DISLET

	  RTS

	  

	  RTS

****************************************************

*           THE DISPLAY DATA FUNCTION              *

****************************************************

*

*

DISLET:   STA    PORTA

	  BCLR   2,PORTA

	  BSET   1,PORTA

	  BSET   3,PORTA

	  BCLR   3,PORTA

	  BCLR   1,PORTA

	  JSR    DELAY

	  RTS

*

*******************************************

*       THE DISPLAY CONTROL FUNCTION      *

*******************************************

*

CONTROL:  STA     PORTA

	  BCLR    2,PORTA   ; SET R/W TO '0'

	  BCLR    1,PORTA   ; SET RS TO '0'

	  BSET    3,PORTA   ; SET E TO '1'

	  BCLR    3,PORTA   ; SET E TO '0'

	  JSR     DELAY   

	  RTS

*

*********************************************

*    THE DISPLAY INITIALIZATION FUNCTION    *

*********************************************

*

INIT:     LDA     #$00

	  JSR     CONTROL

	  LDA     #$10

	  JSR     CONTROL

	  LDA     #$20

	  JSR     CONTROL

	  LDA     #$20

	  JSR     CONTROL

	  LDA     #$80

	  JSR     CONTROL

	  LDA     #$10

	  JSR     CONTROL

	  LDA     #$80

	  JSR     CONTROL

	  LDA     #$00

	  JSR     CONTROL

	  LDA     #$C0 

	  JSR     CONTROL

	  RTS

*

* 

*********************************************

*         THE DELAY FUNCTION  (4ms)         *

*********************************************

*

DELAY:    LDA     #05

LOOP_O:   CLRX

LOOP_I:   DECX

	  BNE     LOOP_I

	  DECA

	  BNE     LOOP_O

	  RTS

*

*********************************************

*        THE DISPLAY WARMUP DELAY (24ms)    *

*********************************************

*

*

WUPDELAY  LDA     #31

LOUT      CLRX

LIN       DECX

	  BNE     LIN

	  DECA

	  BNE     LOUT 

	  RTS

*

*

*********************************************

*       SYSTEM INITIALIZATION SECTION      *

*********************************************

*

	  ORG     $7F1  ; MASK OPTION REGISTER

	   DB     $20

*          

* SET INTERRUPT & RESET VECTOR          

	  ORG     $7FC

	  FDB     START

	  FDB     START

	  





